#!/usr/bin/perl

##
## pxmk2bmp.pl - PixMarkerץǡBMPեؤѴ
##

use strict;
use IO::Seekable;

my $PalmOsBMP;
my @cv5to8;
my @cv6to8; 

$PalmOsBMP = pack(
	'C54',
	0x42,0x4D,
	0x36,0x2C,0x01,0x00,0x00,0x00,0x00,0x00,0x36,0x00,0x00,0x00,0x28,0x00,
	0x00,0x00,0xA0,0x00,0x00,0x00,0xA0,0x00,0x00,0x00,0x01,0x00,0x18,0x00,0x00,0x00,
	0x00,0x00,0x00,0x2C,0x01,0x00,0x13,0x0B,0x00,0x00,0x13,0x0B,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00
);

@cv5to8 = ( 
	0,8,16,25,33,41,49,58,
	66,74,82,90,99,107,115,123,
	132,140,148,156,165,173,181,189,
	197,206,214,222,230,239,247,255
);

@cv6to8 = (
	0,4,8,12,16,20,24,28,
	32,36,40,45,49,53,57,61,
	65,69,73,77,81,85,89,93,
	97,101,105,109,113,117,121,125,
	130,134,138,142,146,150,154,158,
	162,166,170,174,178,182,186,190,
	194,198,202,206,210,215,219,223,
	227,231,235,239,243,247,251,255
);

main:
{
	my $num;	## record num
	my $ofs;	## record offset
	my $i;
	my $bmp;

	open( IFP, $ARGV[0] || "picl16DB.pdb" ) || die "picl16DB.pdb not found";
	binmode( IFP );
	seek( IFP, 0x4C, SEEK_SET ) || die "picl16DB.pdb too short";
	read( IFP, $num, 2 );
	$num = unpack( 'n', $num );

	for ($i=0; $i<$num; $i+=2) {
		seek( IFP, 0x4E+8*$i, SEEK_SET ) || die "picl16DB.pdb too short";
		read( IFP, $ofs, 4 );
		$ofs = unpack( 'N', $ofs );
		seek( IFP, $ofs, SEEK_SET ) || die "picl16DB.pdb too short";
		read( IFP, $bmp, 160*160*2 );
		&putBmp( $i/2, $bmp );
	}
	
	close( IFP );
}

sub putBmp {
	my ( $n, $bmp ) = @_;
	my ( $i, $j );
	my $fname;
	my $wd;
	my ( $r, $g, $b );
	$fname = sprintf( "pxmk_%03d.bmp", $n );
	open( OFP, ">$fname" ) || die "ofp can't open";
	binmode( OFP );
	print OFP $PalmOsBMP;
	for ($i=159; $i>=0; $i--) {
		for ($j=0; $j<160; $j++) {
			$wd = unpack( 'n', substr( $bmp, $i*160*2+$j*2, 2 ) );
			$r = $cv5to8[$wd >> 11];
			$g = $cv6to8[($wd >> 5) & 0x003f];
			$b = $cv5to8[$wd & 0x001f];
			print OFP pack( 'CCC', $b, $g, $r );
		}
	}
	close( OFP );
}
